<?php
namespace Teknisa\DF\Modules\Relatorios\Controllers;

use NFePHP\NFe\MakeNFe;
use NFePHP\NFe\ToolsNFe;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;

use Teknisa\DF\Modules\Relatorios\Services\Dfe22000DetalhamentoNotasFiscaisManifestadaService;

class Dfe22000DetalhamentoNotasFiscaisManifestadaController {
    
    protected $dfe22000DetalhamentoNotasFiscaisManifestadaService;

    public function __construct(Dfe22000DetalhamentoNotasFiscaisManifestadaService $dfe22000DetalhamentoNotasFiscaisManifestadaService) {
        $this->dfe22000DetalhamentoNotasFiscaisManifestadaService = $dfe22000DetalhamentoNotasFiscaisManifestadaService;
        set_time_limit(0);
    }

    public function findNrNSU(request $request, response $response) {
        
        $find = $this->dfe22000DetalhamentoNotasFiscaisManifestadaService->findNrNSU($request);
        
        $response->addDataset(new DataSet("findNrNSU",  $find));
        
        
    }
    
    public function findHistNSU(request $request, response $response) {
        $row = $request->getRow();
        
        $find = $this->dfe22000DetalhamentoNotasFiscaisManifestadaService->findHistNSU($row["NRACESSONFE"]);
        
        $response->addDataset(new DataSet("findHistNSU",  $find));
    }
    /*
    public function getNsuXML(request $request, response $response) {
        $row = $request->getRow();
        
        $find = $this->dfe22000DetalhamentoNotasFiscaisManifestadaService->getNsuXML($row);
        
        $response->addDataset(new DataSet("getNsuXML",  $find));
    }
    */
    public function downloadXML($dsarqxml){
        file_put_contents("aleatorio.xml", $dsarqxml);
    }
    
    public function downloadNsuXML (Request\Filter $request, response $response){   
        $requestConditions = $request->getFilterCriteria()->getConditions();
        $NRACESSONFE = $requestConditions[0]["value"];
        $NRNSU = $requestConditions[1]["value"];
        $findXML = $this->dfe22000DetalhamentoNotasFiscaisManifestadaService->getNsuXML($NRACESSONFE,$NRNSU);

        $dir_file = sys_get_temp_dir().'/'.$NRNSU."-nsu.xml";
        file_put_contents($dir_file, $findXML[0]["DSARQXMLNSUNFE"]);
        
        try {
            
            $response->addDataset(new \Zeedhi\Framework\DataSource\DataSet('downloadNsuXML', array($dir_file)));
        } catch (\Exception $e) {
            throw $e;
        }
    }
	
	
}
